#!/usr/bin/env python
"""
  Otladka metodiki analiza fajl. s-my ext2 etc.;
w dann. fajle - wspomog. podprogrammy.

  Ispolxz.:
- https://www.opennet.ru/docs/RUS/ext2fs_lowlevel/
  -> bob_ext2.zip ;
- http://www.xs4all.nl/~carlo17/howto/undelete_ext3.html
  -> undeext3.htm .
- https://en.wikipedia.org/wiki/Ext2
  -> utw.: root directory is always stored in inode number two.

  Numeraciq blokow (w cepo`kah; sm. read_blok) - s nulq (!).
  A numeraciq fajlow (== inode_nr; sm. anal_dir) w katalogah - 
s edinicy, napr., na sdb2_ext2_2Mb.dat fajl Orleta*.jpg 
w kataloge imeet inode_nr=19, i \to sootw. nomeru gruppy i=0 
i nomeru inody w gruppe j=18. 
  Zame`.: ideq razbiwki na gruppy - dlq v@stkogo diska 
oformlqtx cilindry kak gruppy, i zatem fajly iz odnogo
proekta razme]atx w odnoj gruppe, `toby perehod mevdu takimi
fajlami ne trebowal dwiveniq bloka golowok. (Dlq twerdotelxnyh
diskow - bespolezno). 
  Zame`.: tipi`naq situaciq - fajl zapisan ne w posledowatelxno
idu]ie bloki, a po tipu
  Zame`.: w prosmotrennyh slu`aqh dlinnyj fajl na diske "razorwan" - 
w nego wkliniwaetsq ukazanie o nomerah blokow - sm. kommentarij
k podprog. 'sobratx_fajl'.
"""
from obscie import *
import os,sys,struct,time

def set_whodn(imq0_,ofs0_sec_=0):
 """
 imq0 - napr., '/dev/sdc' ili 'sdc.dat';
 ofs0_sec - sme]enie w sektorah dlq na`ala analiziruemoj oblasti,
 napr., 0 dlq MBR.
 """
 global imq0,ofs0_sec
 # print 'set_whodn: imq0,ofs0_sec = %s %08X' % (repr(imq0_),ofs0_sec_)
 imq0,ofs0_sec = imq0_,ofs0_sec_
 set_whodn_(imq0_,ofs0_sec_=ofs0_sec_)

def read_superblok():
 """
 Superblok - wsegda w sektorah 2..3, t.e. po sme[. 0x400..0x800. 
 """
 print '----- read_superblok -----\\'
 s,errcode = read_nesk_sect(2, n_sect=2, comment='read_superblok')
 assert errcode==0
 print '----- read_superblok -----/'
 return(s)

def read_gdt():
 global s_gdt
 "GDT == Group Descriptor Table."
 print '----- read_gdt -----\\'
 ofs = nr_bloka_gdt*block_size
 s,errcode = read_xxx(ofs,32*group_count)
 assert errcode==0
 s_gdt=s
 print '----- read_gdt -----/'
 return(s)

def anal_superblok(s0):
 global block_size,ino_size,\
  group_count,blocks_per_group,ino_per_group,\
  ino_count,dlina_ino_tab,\
  nr_bloka_gdt

 print '----- anal_superblok -----\\'

 # Rassm. 2 primera - 2 -> 1.5 Mb i 16 -> 15 Mb.

 (n_block_size,) = struct.unpack('L',s0[0x18:0x1C])
 block_size=[1024,2048,4096][n_block_size]  # 1024; 1024
 print 'block_size= %i' % block_size  
 set_razmer_klastera(block_size)

 (ino_count,) = struct.unpack('L',s0[0:4])  # 192; 3760
 print 'ino_count= %i' % ino_count    
 (ino_size,) = struct.unpack('H',s0[88:90]) # 128
 if ino_size!=128: print 'Neovid.!!!'; sys.exit(1)

 (ino_per_group,) = struct.unpack('L',s0[40:44])  # 192; 1880
 print 'ino_per_group= %i' % ino_per_group
 if ino_count%ino_per_group!=0:
  print 'ino_count%ino_per_group=',ino_count%ino_per_group,' - !!!'; sys.exit(1)
 else:
  group_count=ino_count/ino_per_group; # 192/192=1; 3760/1880=2
  print 'group_count=',group_count

 # "Block group_number of this superblock" po adr. 0x400+90 realxno ==0, 
 # po\tomu ego ignor.

 (blocks_per_group,) = struct.unpack('H',s0[32:34])  # 8192; 8192
 print 'blocks_per_group= %i' % blocks_per_group
 # Esli block_size=1024, to superblok = blok 1, a tabl. opis. grupp = blok 2,
 # a esli 2048 ili 4096 - to -//-     = `astx bloka 0, a -//-       = blok 1.
 if block_size==1024: nr_bloka_superbl=1
 else: nr_bloka_superbl=0
 print 'blok, sod. superblok: '+str(nr_bloka_superbl)  # U nas =1.

 # GDT = group descriptor table .
 nr_bloka_gdt=nr_bloka_superbl+1
 print 'nr_bloka_gdt=',nr_bloka_gdt  # =2.

 opis_grupp_w_bloke=block_size/32  # 32; 32
 if group_count%opis_grupp_w_bloke==0: dlina_gdt=group_count/opis_grupp_w_bloke
 else: dlina_gdt=group_count/opis_grupp_w_bloke+1
 # 1/32 -> 1; 2/32 -> 1 .
 print 'dlina_gdt:',group_count,'/',opis_grupp_w_bloke,'->',dlina_gdt
 print 'bloki, sod. gdt: '+str(nr_bloka_gdt)+'..'+str(nr_bloka_gdt+dlina_gdt-1)
 # -> 2..2; 2..2 .
 # Sootwetstwenno w na`ale 2-go bloka w s-me s 1.5 Mb u nas nahoditsq
 # odno opisanie gruppy (dliny 32 bajta). a w s-me s 15 Mb -
 # dwa opisaniq gruppy (kavdoe po 32 bajta). 

 # for i in range(dlina_gdt): 
 #  nr_bloka=nr_bloka_gdt+i; print nr_bloka; zapis_blok(nr_bloka)

 inod_w_bloke=block_size/ino_size  # 1024/128 = 8 .
 if ino_per_group%inod_w_bloke==0: dlina_ino_tab=ino_per_group/inod_w_bloke
 else: dlina_ino_tab=ino_per_group/inod_w_bloke+1
 print 'dlina_ino_tab:',ino_per_group,'/',inod_w_bloke,'->',dlina_ino_tab
 # 192 / 8 -> 24; 1880 / 8 -> 235 .
 # Napr., ino_per_group=184, ino_size=128, block_size==1024;
 # togda w bloke pome]. 1024/128=8 inode';
 # togda na tabl. inode' treb. 184/8+1 = 24 bloka.

 print '----- anal_superblok -----/'

 return(block_size,ino_size,
   group_count,blocks_per_group,ino_per_group,
   ino_count,dlina_ino_tab,
   nr_bloka_gdt)

def analiz_gruppy(s_gdt,n, otlad=True):
 """
Table 2. A group descriptor
Bytes	type	Description
 0 ..  3	__le32	Blocks bitmap block
 4 ..  7	__le32	Inodes bitmap block
 8 .. 11	__le32	Inodes table block
12 .. 13	__le16	Free blocks count
14 .. 15	__le16	Free inodes count
16 .. 17	__le16	Directories count
18 .. 31		Reserved 
 """
 print '----- analiz_gruppy '+str(n)+' -----\\'
 s = s_gdt[(n*32):(n*32+18)]
 if otlad: show16(s)
 hh = struct.unpack('LLLHHH',s)
 (bl_bitm_bl,ino_bitm_bl,ino_tab_bl,n_free_bl,n_free_ino,n_dire) = hh
 if otlad: print 'blocks bitmap block =',bl_bitm_bl,'-> %08X' % (bl_bitm_bl*block_size)
 if otlad: print 'inodes bitmap block =',ino_bitm_bl,'-> %08X' % (ino_bitm_bl*block_size)
 j0 = ino_tab_bl
 j1 = ino_tab_bl+dlina_ino_tab-1
 ofs_0 = ino_tab_bl*block_size
 ofs_1 = (ino_tab_bl+dlina_ino_tab)*block_size
 if otlad: print 'inodes table block = %d..%d -> %08X..%08X' % (j0,j1,ofs_0,ofs_1)
 if otlad: print 'free blocks count=',n_free_bl
 if otlad: print 'free inodes count=',n_free_ino
 if otlad: print 'directories count=',n_dire
 print '----- analiz_gruppy '+str(n)+' -----/'
 return(hh)

def izwl_inode(ino_tab_bl,j, otlad=False):
 ofs = ino_tab_bl*block_size+j*128
 s_inode,errcode = read_xxx(ofs,128, otlad=otlad, comment='izwl_inode')
 return(s_inode)

def anal_inode(s, otlad=False):
 """
.  0..  1   __le16     File mode
   2..  3   __le16     Low 16 bits of Owner uid
+  4..  7   __le32     Size in bytes
   8.. 11   __le32     Access time
  12.. 15   __le32     Creation time
+ 16.. 19   __le32     Modification time
  20.. 23   __le32     Deletion Time
  24.. 25   __le16     Low 16 bits of Group Id
  26.. 27   __le16     Links count
+ 28.. 31   __le32     Blocks count
. 32.. 35   __le32     File flags
  36.. 39   linux1     OS dependent 1
+ 40.. 99   __le32[15] Pointers to blocks
 100..103   __le32     File version (for NFS)
 104..107   __le32     File ACL
 108..111   __le32     Directory ACL
 112..115   __le32     Fragment address
 116..127   linux2     OS dependent 2
 """
 assert len(s)==128

 # modif - na 1-m meste, t.k. po modif==0 osu]. return.
 (modif,) = struct.unpack('L',s[16:20])
 if modif==0: return(None)
 t=time.localtime(modif); 
 ss=(t.tm_year,t.tm_mon,t.tm_mday,t.tm_hour,t.tm_min,t.tm_sec)
 if otlad: print 'ss_= (%4d-%02d-%02d %02d:%02d:%02d)' % ss

 (mode,)=struct.unpack('H',s[0:2])
 (flags,)=struct.unpack('L',s[32:36])
 # if otlad: print 'mode= %04X (0%o); flags=%08X ' % (mode,mode,flags)

 (siz,) = struct.unpack('L',s[4:8])
 (blocks,) = struct.unpack('L',s[28:32])  # Neqsno - wdwoe > ovidaemogo!
 if otlad:
  print 'siz= %d' % (siz,)
  # print 'blocks= %d' % (blocks,)

 p=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]

 for k in range(15):
  (p[k],) = struct.unpack('L',s[40+k*4:40+(k+1)*4]); 
  # if p[k]!=0: zapis_blok(f0,imq_,block_size,p[k])
 if otlad: print 'p=',p
 
 return(ss,siz,blocks,p)

def rekurs_sobratx_fajl(f1,ostalosx,p,glub):

 print 'glub,p,ostalosx=',glub,p,ostalosx
 if ostalosx==0: return(0)

 if p==0:
  # print 'p=0 - return';
  return(0)
 if glub==1: print 'rekurs_sobratx_fajl: glub,p=',glub,p
 # f0.seek(p*block_size); s=f0.read(block_size)

 print 'rekurs_sobratx_fajl - pered read_blok; p=',p
 s,errcode = read_blok(p)
 print 'rekurs_sobratx_fajl - posle read_blok; p=',p

 if glub==0:
  if ostalosx<block_size: f1.write(s[:ostalosx]); ostalosx=0
  else: f1.write(s); ostalosx=ostalosx-block_size
 else:
  for i in range(block_size/4): 
   p,=struct.unpack('L',s[4*i:4*(i+1)])
   if p!=0: ostalosx = rekurs_sobratx_fajl(f1,ostalosx,p,glub-1)
   else: break
 return(ostalosx)

def sobratx_fajl(imq_,p,siz,modif):
 """
 p - spisok nomerow blokow iz inode'y.
 Naprimer, na sdb2_ext2_2Mb.dat fajl Orleta*.jpg ->
      0    1    2    3    4    5    6    7    8    9   10   11   12
 p= [418, 419, 420, 421, 422, 423, 424, 425, 426, 427, 428, 429, 430, 0, 0]
 - p[0]..p[11] sodervat nomera blokow, prinadl. fajlu (bloki 418..429),
 no p[12] sootw. tomu, `to w 430-m bloke nahodqtsq nomera 
 blokow prodolveniq - 431 i dalee, tak `to fajl na diske
 "razorwan" - w nego wkliniwaetsq ukazanie o nomerah blokow.
 """
 print '----- sobratx_fajl -----\\'

 print 'sobratx_fajl:',repr(imq_)  # ,p,siz,modif
 f1=open(imq_,'wb')
 ostalosx=siz; 
 for i in range(12):
  if ostalosx==0: break
  ostalosx=rekurs_sobratx_fajl(f1,ostalosx,p[i], 0)
 if p[12]!=0 and ostalosx>0: ostalosx=rekurs_sobratx_fajl(f1,ostalosx,p[12],1)
 if p[13]!=0 and ostalosx>0: ostalosx=rekurs_sobratx_fajl(f1,ostalosx,p[13],2)
 if p[14]!=0 and ostalosx>0: ostalosx=rekurs_sobratx_fajl(f1,ostalosx,p[14],3)
 f1.close()
 
 y,mo,d,h,m,s = modif
 time_=time.mktime((y,mo,d,h,m,s,-1,-1,-1))
 # os.utime(imq_,(time_,time_))

 print '----- sobratx_fajl -----/'

def anal_dir(s):
 """
Table 4. A Directory Entry
Bytes	type	Description
0 .. 3	__le32	Inode number
4 .. 5	__le16	Directory entry length
6	__u8	Name length
7	__u8	File Type
8	char[]	File-, symlink- or directory name
 """
 print '----- anal_dir -----\\'
 ofs0=0
 sootw = {}
 while True:
  inode_nr, = struct.unpack('L',s[ofs0+0:ofs0+4])
  # dir_entry_len - wrode dlina zapisi pro fajl pl;s pro udal@nn. fajly za nim.
  dir_entry_len, = struct.unpack('H',s[ofs0+4:ofs0+6])
  name_len, = struct.unpack('B',s[ofs0+6])
  if name_len==0: break
  file_type, = struct.unpack('B',s[ofs0+7])  # 1 - fajl, 2 - directory.
  imq = s[ofs0+8:ofs0+8+name_len]
  # name_len_ - s dopolneniem nulqmi w konce.
  name_len_=name_len
  while name_len_%4!=0: name_len_+=1
  ofs0 = ofs0+8+name_len_
  print '%3d %3d  %08X  / %3d %3d %s' % \
    (dir_entry_len,file_type,ofs0,inode_nr,name_len,repr(imq))
  if inode_nr in sootw.keys():
   print 'Pereopr. sootw. dlq inode_nr - ignoriruem!'
  else:
   sootw[inode_nr] = imq
 print '----- anal_dir -----/'
 return(sootw)

def ww_dir(imq_dir):
 f0 = open(imq_dir,'rb')
 s = f0.read()
 f0.close()
 return(s)

def izwl_fajl(i,j,imq=None):
 """
 i - nomer gruppy (in range(group_count));
 j - nomer inody (in range(ino_per_group));
 imq - imq sozdawaemogo fajla; esli None, to 
     nado sozd. imq wida 'fajl0_18.dat';
     imena iz kataloga (= sootw[nomer]) ne ispolxzuem,
     t.k. \to sozdalo by risk zateretx fajl s 
     sowpaw[im imenem. 
   Wremq modifikacii ostawlqem teku]ee, `toby fajl
 bylo leg`e najti. 
 """
 print '----- izwl_fajl -----\\' 
 nomer = ino_per_group*i+j+1  # Dlq korn. kat. i=0, j=1 -> nomer=2.
 print 'izwl_fajl: i,j=',i,j,'-> nomer=',nomer 
 hh = analiz_gruppy(s_gdt,i, otlad=False)
 ino_tab = hh[2]  # Nomer na`alxnogo bloka tablicy inod dlq dannoj gruppy.
 s_inode = izwl_inode(ino_tab,j, otlad=True)
 resu = anal_inode(s_inode, otlad=True)
 assert resu!=None
 modif,siz,blocks,p = resu
 # write_xxx('inode%04d.dat' % (nomer,),s_inode)
 if nomer in sootw.keys():
  print 'nomer,imq=',nomer,repr(sootw[nomer])
 else:
  print 'nomer=',nomer,'- imq neizwestno !!!'
 if imq!=None: imq_out=imq
 else: imq_out = 'fajl'+str(i)+'_'+str(j+1)+'.dat'
 sobratx_fajl(imq_out,p,siz,modif)
 print '----- izwl_fajl -----/' 

def read_root_dir():
 # So`etanie i=0, j=1 sootw. kornewomu katalogu.
 global sootw
 print '----- read_root_dir -----\\' 
 i=0
 hh = analiz_gruppy(s_gdt,i)
 ino_tab = hh[2]  # Nomer na`alxnogo bloka tablicy inod dlq dannoj gruppy.
 j=1
 s_inode = izwl_inode(ino_tab,j, otlad=True)
 resu = anal_inode(s_inode, otlad=True)
 modif,siz,blocks,p = resu
 sobratx_fajl('root_dir.dat',p,siz,modif)

 root_dir = ww_dir('root_dir.dat')
 sootw = anal_dir(root_dir)
 # -> sootw[inode_nr] = imq .
 print '----- read_root_dir -----/' 
 return(root_dir,sootw)

# --------

if __name__=='__main__':
 ss=dir()
 for s in ss:
  print s
